import { init, ECharts, use } from 'echarts/core';
import { SetOptionOpts, EChartsOption } from 'echarts';
import { FC, HTMLAttributes } from 'react';

type EChartsEventProp = 'onAxisAreaSelected' | 'onBrush' | 'onBrushEnd' | 'onBrushSelected' | 'onClick' | 'onContextMenu' | 'onDataRangeSelected' | 'onDataViewChanged' | 'onDataZoom' | 'onDoubleClick' | 'onDownplay' | 'onFinished' | 'onGeoSelectChanged' | 'onGeoSelected' | 'onGeoUnselected' | 'onGlobalCursorTaken' | 'onGlobalOut' | 'onHighlight' | 'onLegendInverseSelect' | 'onLegendScroll' | 'onLegendSelectChanged' | 'onLegendSelected' | 'onLegendUnselected' | 'onMagicTypeChanged' | 'onMouseDown' | 'onMouseMove' | 'onMouseOut' | 'onMouseOver' | 'onRendered' | 'onRestore' | 'onSelectChanged' | 'onTimelineChanged' | 'onTimelinePlayChanged';
type EChartEventsProps = {
    [K in EChartsEventProp]?: () => any;
};

type UseECharts = (options: UseEChartsOptions) => [(node: HTMLDivElement) => void, ECharts | undefined];
type UseEChartsOptions = EChartEventsProps & SetOptionOpts & EChartsOption & Parameters<typeof init>[2] & {
    group?: ECharts['group'];
    theme?: Parameters<typeof init>[1];
    use?: Parameters<typeof use>[0];
};
declare const useECharts: UseECharts;

declare const useConnect: (group: string) => (boolean | ((connected: boolean) => void))[];

type ContainerProps = Omit<HTMLAttributes<HTMLDivElement>, 'onClick' | 'onDoubleClick' | 'onMouseDown' | 'onMouseMove' | 'onMouseOut' | 'onMouseOver'>;
type EChartProps = ContainerProps & UseEChartsOptions;
declare const EChart: FC<EChartProps>;

export { EChart, EChartProps, UseEChartsOptions, useConnect, useECharts };
